/**
 *
 */
void updateWindowInfo
(
     datetime infopos
   , int      iday
   , int      ises
   , string   data[]
)
{
   int     i 
         , imax     = ArraySize(data)
         , irow
         , startrow = WindowPriceMax(giWinId)-2
         ;
   
   for (i=0, irow=startrow; i<imax; i++, irow--)
   {
      createText( "#" + iday + "#" + ises + ".info." + i
         , infopos
         , irow
         , data[i]
         , MPLFONTSIZE-1, MPLFONTNAME2, WindowInfoColor
         , giWinId
         );       
   
   }
   
}

void updateWindowInfo2
(
     datetime infopos
   , int      iday
   , int      ises
   , string   data[]
)
{
   int     i 
         , imax     = ArraySize(data)
         , irow
         , startrow = WindowPriceMax(giWinId)-2
         ;
   
   for (i=0, irow=startrow; i<imax; i++, irow--)
   {
      createText( "#" + iday + "#" + ises + ".info." + i
         , infopos
         , irow
         , data[i]
         , MPLFONTSIZE-1, MPLFONTNAME2, EuColor
         , giWinId
         );       
   
   }
   
}
/**
 *
 */
void drawBar( int iday, int ises, int pos, double o, double h, double l, double c )
{
   color barclr;
   if (c>o)barclr=BarBullColor; else
   if (c<o)barclr=BarBearColor; else
           barclr=BarNetralColor;   

   createTl("#" + iday + ".1.1.#" + ises + ".bar.spread"
      , Time[pos], h
      , Time[pos], l
      , barclr, STYLE_SOLID, 3, false
      );            
   
   createTl("#" + iday + ".1.1.#" + ises + ".bar.o"
      , MathMax(Time[pos+1], Time[pos] - Period()*60), o
      , Time[pos], o
      , barclr, STYLE_SOLID, 3, false
      ); 
      
   createTl("#" + iday + ".1.1.#" + ises + ".bar.c"
      , MathMax(Time[pos-1], Time[pos] + Period()*60), c
      , Time[pos], c
      , barclr, STYLE_SOLID, 3, false
      );       
}

/**
 *
 */
bool isHistoryOK()
{    
   //if (IsConnected())
   //{
   if (  (!checkHist(ProfileDataTf)) 
      || (!checkHist(PERIOD_D1)) 
      //|| !checkHist(Period())
   )  return(false); 
   //}
   //Comment("");
   return(true);
}

/**
 *
 */
bool checkHist(int tf)
{

   int i, bars, err;
   
   bars = iBars(Symbol(), tf);      
   err  = GetLastError();   
      
   if (err==0) return(true);
   //Comment("Waiting for timeframe ", tf, " minutes to be ready");   
   
   return(false);

}

/**
 *getHHLL                                                          
*/
void getHHLL
(
     int       tf
   , int       sb
   , int       eb
   , double&   hh
   , double&   ll
)
{
   hh = iHigh ( NULL, tf, iHighest(NULL, tf, MODE_HIGH, (sb - eb)+1, eb) );
   ll = iLow  ( NULL, tf, iLowest (NULL, tf, MODE_LOW,  (sb - eb)+1, eb) );
} 
/**
 *getSesSE
 *get startbar and endbar from one session
*/
void getSesSE
(
     int          tf
   , datetime     dtsb
   , datetime     dteb 
   , int&         sb
   , int&         eb
)
{
   sb = iBarShift(NULL, tf, dtsb);
   eb = iBarShift(NULL, tf, dteb);
   
   //fix ibarshift during weekstart..   or bar time like 10.03
   if (iTime(NULL, tf, sb) < dtsb) sb--;  
   if (eb>sb) eb=sb;  
}
/**
 *
 */
void getDaySesObj
(
     string objname
   , int&   idayobj
   , int&   isesobj
)
{

   int idaydelim1, idaydelim2, isesdelim1, isesdelim2;
   
   //--objname example : ay.mpls.#0.1.2.#2.letter.0-0
   idaydelim1 = StringFind(objname, "#");    
   idaydelim2 = StringFind(objname, ".", idaydelim1);                    
   idayobj    = StrToInteger(StringSubstr(objname, idaydelim1+1, (idaydelim2-idaydelim1)-1)); 

   isesdelim1 = StringFind(objname, "#", idaydelim2);
   isesdelim2 = StringFind(objname, ".", isesdelim1);
   isesobj    = StrToInteger(StringSubstr(objname, isesdelim1+1, (isesdelim2-isesdelim1)-1));  
}

/**
 *
 */
bool secondDiff()
{
   static datetime lasttime ;
   int diff = TimeLocal() - lasttime ;

   if (diff >= UpdateInterval)
   {
      lasttime = TimeLocal();
      return (true);
   }
   
   return (false);
   
}
/**
 *
 */
bool isNewBarDataTf()
{
   static datetime LastBar;
   datetime CurrBar = iTime(NULL, ProfileDataTf, 0);

   if(LastBar != CurrBar)
   {
      LastBar = CurrBar;
      return (true);
   }
   return(false);  
}

//+------------------------------------------------------------------+
//| addStr                                                           |
//+------------------------------------------------------------------+ 
string addStr(string str, string aChar, int maxlength, bool atbeginning = true)
{
   int l = maxlength - StringLen(str);
   for (int i=0; i<l; i++)
   {
      if (atbeginning) str = aChar + str;
      else str = str + aChar;
   }
      
   return(str);
}

/**
 *
 */
 void moveObj
 (
     string  objname
   , int     objtype
   , int     adj
 )
 {
   datetime t1, t2;
   int      ibart1, ibart2;   
   
   t1     = ObjectGet(objname, OBJPROP_TIME1);
   ibart1 = iBarShift(NULL, 0, t1);                                             

   switch (objtype)
   {
      case OBJ_TEXT:
         //--delete obj when new OBJPROP_TIME1 is out of minimum chart time
         if (ibart1+adj>Bars-1) ObjectDelete(objname);                               
         else ObjectSet(objname, OBJPROP_TIME1, Time[ibart1+adj]);  
         break;
      case OBJ_TREND:
      case OBJ_RECTANGLE:
         t2 = ObjectGet(objname, OBJPROP_TIME2);
         ibart2 = iBarShift(NULL, 0, t2); 
      
         if (ibart1+adj>Bars-1) ObjectDelete(objname);//--delete it                                                                                     
         else
         {                                
            ObjectSet(objname, OBJPROP_TIME1, Time[ibart1+adj]);  
            ObjectSet(objname, OBJPROP_TIME2, Time[ibart2+adj]);                                                               
         }
      break;
   }     
 }