//+------------------------------------------------------------------+
//|                         ay-TPOChart-Session.v1.20-LOCK_MOD.mq4** |
//|                                                                  |
//|                                 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015"
#property description "2015_03_20: more session mix option added"
#property version "4.00"
#property link      ""

#property indicator_separate_window
#property indicator_minimum -5
#property indicator_maximum 1
/******************************************************************\\\

** LOCK version 0.1 ** 2014_05_03: added halfback line, less info, volumes newly added, 
splitted 1st period on current bar, all updated to mt4 >=build628
*** LOCK version 0.2 ** 2015_08_18: added a new session and the ability to split only current session and not only the entire day. 
It works on build 840.
**** LOCK version 0.3 ** 2015_08_19: now there are 5 sessions and 4 possible merged profiles. 
Sydney+Asia+Europe+US is the classical overnight profile.
**** LOCK version 0.4 ** 2016_03_20: more session mix possibilities
*******************************************************************\\\
 * MP Library 
 * dont change anything in this mp library block, unless YKWYD.....
 ******************************************************************///say something here...
#include <ay-mplib.const.v102.mqh>                                  //
                                                                    //
#import "ay-mplib.v102.ex4"                                         //
void MpGet                                                          //
   (                                                                //   
        double    dparam[4]                                         //
      , int       iparam[4]                                         //
      , double    arates[][6]                                       //
      , double&   mpdataperrow[][MPSIZE]                            //result: price per row (price, tpo, vol)  
      , int&      mplinesidx[MPLNSIZE]                              //result: lines index
      , double&   mptotal[MPTSIZE]                                  //result: total (tpo, vol)
      , int&      mpletter[][MPLTSIZE]                              //result: letter  
   );                                                               //
#import                                                             //
/******************************************************************\\\
 * End MP Library 
 ******************************************************************///
 
/******************************************************************\\\
 * Indicator Constant
 ******************************************************************/// 
#define IND_NAME        "TPOChart Session v1.20"
#define SES_START       0                                            //
#define SES_END         1                                            //
#define S_SES           0                                            //Sydney Session
#define A_SES           1                                            //Asia Session
#define E_SES           2                                            //Europe Session
#define U_SES           3                                            //US Pre-open Session
#define P_SES           4                                            //US Pit Session
#define D_SES           5                                            //Full Day Session
#define ON_SES          6                                            //OVERNIGHT Session
#define MPLFONTNAME     "lucida sans typewriter bold"
#define MPLFONTNAME2    "lucida sans typewriter"

#define MG_SYDNEY_ASIA  "A"
#define MG_SYDNEY_ASIA_EUROPE  "B"
#define MG_SYDNEY_ASIA_EUROPE_US  "C"
#define MG_SYDNEY_ASIA_EUROPE_US_USPIT  "D"
#define MG_ALL  "E"
#define MG_US_USPIT  "F"

/******************************************************************\\\
 * End Indicator Constant
 ******************************************************************/// 

//--- input parameters
extern bool       EnableMergeProfile       = false;
extern string     MergeProfileInfo         = "A:S+A-E-U-Up,B:S+A+E-U-Up,C:S+A+E+U-Up,D:S+A+E-U+Up,E:ALL,F:S-A-E-U+Up";
extern string     MergeProfile             = "F";
extern bool       ExtendIB                 = false;
extern bool       ShowSplitProfileDay      = false;
extern bool       ShowSplitProfileSes      = true;
extern bool       PaintLettersOnVolume     = false;
extern bool       ShowHorizontalVolume     = true;
extern bool       ShowVolumeRatio          = false;
extern double     MinVolumeRatio           = 1.5;
extern string     SydneyOpen               = "00:00";
extern string     AsiaOpen                 = "03:00";
extern string     EuropeOpen               = "10:00";
extern string     USOpen                   = "15:00";
extern string     USPitOpen                = "16:30";
extern int        NumDays                  = 7;
extern int        SplitProfileNumDays      = 0;
extern string     SplitProfileNumSesInfo   = "0 splits current session";
extern int        SplitProfileNumSes       = 0;
extern int        RowHeight                = 1;
extern int        ProfileDataTf            = 30;
extern double     VAPercent                = 70.0;
extern int        IBNumBars                = 2;
extern int        UpdateInterval           = 2;
extern int        MPLFONTSIZE              = 8;
extern string     spr1                     = "Colors.............";
extern color      SyColor                  = Khaki;
extern color      AsColor                  = DarkKhaki;
extern color      EuColor                  = Magenta;
extern color      UsColor                  = Aqua;
extern color      UsPitColor               = DodgerBlue;
extern color      OVERNIGHTColor           = Orchid;
extern color      FullDayColor             = White;
extern color      VAColor                  = C'41,41,75';
extern color      POCColor                 = Yellow;
extern color      HistogramColor           = C'0,64,128';
extern color      BarBullColor             = DodgerBlue;//C'0,200,0';
extern color      BarBearColor             = DarkOrange;//C'200,0,0';
extern color      BarNetralColor           = DimGray;
extern color      OpenCloseColor           = Yellow;
extern color      WindowInfoColor          = Yellow;
extern color      UpVolumeColor            = DodgerBlue;
extern color      DownVolumeColor          = DarkOrange;
extern color      NeutralVolumeColor       = DimGray;


//-->global vars
int        giStep
         , giDigits
         , giWinId
         ;
double     gdaRates[][6]
         , gdOneTick
         , gdPoint
         ;     
color      gcHistoColor;         
bool       gbFirstRun = true;
string     gsaLetter[] = 
            {
             "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"
            ,"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"
            } 
         , gsPref = "ay.mpls."
         ; 
color      gcSesColor[7];
datetime   gdtaMST[][5][4];   //--array market session time;            
//<--global vars   
 
#include <ay-object.func.v1.1.mqh>
#include <ay-TPOChart-Session.v1.20.helper.mqh>


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   IndicatorShortName(IND_NAME);
      
   if (Point == 0.001 || Point == 0.00001) 
   { gdPoint = Point*10; giDigits = Digits - 1; }
   else 
   { gdPoint = Point; giDigits = Digits; } 
   
   gdOneTick = 1/MathPow(10, giDigits);
   
   giStep = MathMax(RowHeight, 1);
   
   ArrayCopyRates(gdaRates, NULL, ProfileDataTf);        
   
   gcSesColor[D_SES] = FullDayColor;
   gcSesColor[A_SES] = AsColor;
   gcSesColor[E_SES] = EuColor;
   gcSesColor[U_SES] = UsColor;
   gcSesColor[ON_SES] = OVERNIGHTColor;
   gcSesColor[P_SES] = UsPitColor;
   gcSesColor[S_SES] = SyColor;
   if (EnableMergeProfile && MergeProfile == MG_ALL) gcSesColor[S_SES] = gcSesColor[D_SES];
   else if (EnableMergeProfile && MergeProfile == MG_SYDNEY_ASIA_EUROPE_US) gcSesColor[S_SES] = gcSesColor[ON_SES];
   
   
   
   //--
   ArrayResize(gdtaMST, NumDays);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{         
   delObjs();
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   
   ArrayCopyRates(gdaRates, NULL, ProfileDataTf);
   
   static bool       isbusy;
   static datetime   lastdaystart;
   static datetime   lastsesstart;   
   
   if (isbusy || !isHistoryOK() || !secondDiff() ) { return(0); }   
   
   isbusy = true;   
   
   datetime   currtime     = iTime(NULL, ProfileDataTf, 0);
   datetime   currsesstart;
   datetime   currdaystart = StrToTime( TimeToStr(currtime, TIME_DATE) + " " + SydneyOpen );
   datetime   dtSO               //--dt sydney open
            , dtSE               //--dt sydney end
            , dtAO               //--dt asia open
            , dtAE               //--dt asia end
            , dtEO               //--dt europe open
            , dtEE               //--dt europe end
            , dtUO               //--dt us open
            , dtUE               //--dt us end
            , dtUPO              //--dt us pit open
            , dtUPE              //--dt us pit end
            ;   
   string     stribdtime;
   int        iday, ises, maxdays = NumDays           
            , ibd, ibarday = iBarShift(NULL, PERIOD_D1, currtime)    //--so you can reply in ea
            ; 
   bool       bdelallobjs; //--
   
   
   giWinId = WindowFind(IND_NAME);
   
   if (currdaystart > currtime) currdaystart -= PERIOD_D1*60;
   
   if (currdaystart != lastdaystart)
   {
      //maxdays = NumDays;      
      for (iday=0, ibd=ibarday; iday<maxdays; iday++, ibd++)
      {
         stribdtime = TimeToStr(iTime(NULL, PERIOD_D1, ibd), TIME_DATE);
         
         dtSO  = StrToTime( stribdtime + " " + SydneyOpen );
         //--Sydney open is in future time
         if ( TimeHour(currtime) < TimeHour(dtSO) ) dtSO -= PERIOD_D1*60;
         
         dtAO  = StrToTime( stribdtime + " " + AsiaOpen );
         if (dtAO<dtSO) dtAO += PERIOD_D1*60;
            
         dtEO  = StrToTime( stribdtime + " " + EuropeOpen );
         if (dtEO<dtAO) dtEO += PERIOD_D1*60;
         
         dtUO  = StrToTime( stribdtime + " " + USOpen );  
         if (dtUO<dtEO) dtUO += PERIOD_D1*60; 
         
         dtUPO  = StrToTime( stribdtime + " " + USPitOpen );  
         if (dtUPO<dtUO) dtUPO += PERIOD_D1*60;
                           
         dtSE  = dtAO - 1;                   //--profile end @AO
         dtAE  = dtEO - 1;                   //--profile end @EO            
         dtEE  = dtUO - 1;                   //--profile end @UO
         dtUE  = dtUPO - 1;                  //--profile end @UPO
         dtUPE  = dtSO + (PERIOD_D1*60) - 1; //--profile end @next SO
      
         if (EnableMergeProfile && MergeProfile == MG_SYDNEY_ASIA) dtSE = dtEO -1;
         if (EnableMergeProfile && MergeProfile == MG_SYDNEY_ASIA_EUROPE)   dtSE = dtUO -1;
         if (EnableMergeProfile && MergeProfile == MG_SYDNEY_ASIA_EUROPE_US)   dtSE = dtUPO-1;
         if (EnableMergeProfile && MergeProfile == MG_SYDNEY_ASIA_EUROPE_US_USPIT)   dtSE = dtUO-1;
         if (EnableMergeProfile && MergeProfile == MG_SYDNEY_ASIA_EUROPE_US_USPIT)   dtUE = dtUPE;
         if (EnableMergeProfile && MergeProfile == MG_ALL)     dtSE = dtUPE; 
         if (EnableMergeProfile && MergeProfile == MG_ALL) SyColor = White;
         if (EnableMergeProfile && MergeProfile == MG_US_USPIT) dtUE = dtUPE;
         
      
         gdtaMST[iday][S_SES][SES_START]   = dtSO;
         gdtaMST[iday][S_SES][SES_END]     = dtSE;
      
         gdtaMST[iday][A_SES][SES_START]   = dtAO;
         gdtaMST[iday][A_SES][SES_END]     = dtAE;      
      
         gdtaMST[iday][E_SES][SES_START]   = dtEO;
         gdtaMST[iday][E_SES][SES_END]     = dtEE;
               
         gdtaMST[iday][U_SES][SES_START]   = dtUO;
         gdtaMST[iday][U_SES][SES_END]     = dtUE;   
         
         gdtaMST[iday][P_SES][SES_START]   = dtUPO;
         gdtaMST[iday][P_SES][SES_END]     = dtUPE; 
         
         gdtaMST[iday][D_SES][SES_START]   = dtSO;
         gdtaMST[iday][D_SES][SES_END]     = dtUPE; 
         
         gdtaMST[iday][ON_SES][SES_START]   = dtSO;
         gdtaMST[iday][ON_SES][SES_END]     = dtUE; 
          
      }

      lastdaystart = currdaystart;
      bdelallobjs  = true;
   }
   
   //--find current session start time
   for (ises = S_SES; ises <= P_SES; ises++)      
   {   
      if ( gdtaMST[0][ises][SES_END] > currtime ) 
      {
         currsesstart =  gdtaMST[0][ises][SES_START];
         if (lastsesstart != currsesstart)
         {
            bdelallobjs  = true;
            lastsesstart = currsesstart;
         }
         break;
      }
   }
   
   if (bdelallobjs)
   {
      delObjs();
      maxdays = NumDays;
   }
   else maxdays = 1;      
   
   //-->|
   createProfile (maxdays, currtime, currsesstart);   
   //<--|
   
   isbusy = false;   
   
   return(0);   
}

void createProfile
(
     int       maxdays
   , datetime  currtime
   , datetime  currsesstart   
)
{
   static int      lastmaxtpo;
   
   //-->MpGet Vars
   double     hh, ll, hhday, llday
            , rhh, rhhday  //round hh to rowheight
            , rll, rllday  //round ll to rowheight;
            ;
            //, ibh, ibl;
   int        sb, eb, sbday, ebday;    
   double     mpdata  [][MPSIZE];
   int        mplines   [MPLNSIZE];
   double     mptotal   [MPTSIZE];
   int        mpletter[][MPLTSIZE];   
   double     dparam[4];
   int        iparam[4];      
   int        ratessize = iBars(NULL, ProfileDataTf)
            , mpdatasize;
   //<--MpGet Vars         
   
   
   double     poc, midrowpoc, vpoc,vah, val, open, close, halfback   
            , rg = (giStep/1.0)/(MathPow(10,giDigits))
            , ibh, ibl        
            ;    
   int        iday, ises
            , maxtpo
            , startprofile, startprofileday
            , laststartprofile = -7
            , space = 3                                              //--space between profile
            , objtotal, iobj, objtype
            , idaydelim1, idaydelim2, isesdelim1, isesdelim2
            , idayobj, isesobj
            , textwidth            
            ;                        
   bool       bcurrsession
            , newbar = isNewBarDataTf()
            , isobjmp
            , bmaxdays1andcurrses
            , bmaxtpochange
            , bmaxtpochangeornewbar
            , bmaxtpochangeandnewbar
            , bobjnotincurrses
            , bobjincurrses
            ;             
   string     objname, strinfo[4];     
  
  
  if (ShowHorizontalVolume) space += 1;
  if (ShowVolumeRatio)      space += 0;                    
    
   //-->DAY LOOP
      
   
   
   for (iday=0; iday<maxdays; iday++)
   {      
      //-->session loop
      for (ises=4; ises>=0; ises--)      
      {               
         //--session not yet started
         if (gdtaMST[iday][ises][SES_START] > currtime ) continue;
         
         //--skip when session is merged to prev sesssion
         if (  EnableMergeProfile 
               && 
               (            
                  (MergeProfile == MG_SYDNEY_ASIA && ises==1)
                  || 
                  (MergeProfile == MG_SYDNEY_ASIA_EUROPE && (ises==1 || ises==2))
                  || 
                  (MergeProfile == MG_SYDNEY_ASIA_EUROPE_US && (ises==1 || ises==2 || ises==3))
                  ||
                  (MergeProfile == MG_SYDNEY_ASIA_EUROPE_US_USPIT && (ises==1 || ises==2))                  
                  ||
                  (MergeProfile == MG_SYDNEY_ASIA_EUROPE_US_USPIT && ises==4)                  
                  ||
                  (MergeProfile == MG_ALL && (ises==1 || ises==2 || ises==3 || ises==4))
                  ||
                  (MergeProfile == MG_US_USPIT && ises==4)
               )
            )  continue;
                     
         //--are we in current session?
         if ( gdtaMST[iday][ises][SES_START] == currsesstart ) 
              bcurrsession = true;
         else bcurrsession = false;                           

         //--only update current session
         if (maxdays == 1 && !bcurrsession) break;         
         
         //--get session start bar and end bar                        
         getSesSE
         (
              ProfileDataTf
            , gdtaMST[iday][ises][SES_START]
            , gdtaMST[iday][ises][SES_END]
            , sb
            , eb
          );
                           
         if (    sb<0 
              || eb<0                              
              || ( sb==eb && iday != 0 ) //stupid sunday bar... arrgghh when asia start set to sydney open
            ) 
         {
            //Print("skipping day#", iday, " ses#", ises, " sb ", sb, " eb ", eb);
            continue;
         }
         

                  
         //-->Prepare data for library fn call    
         getHHLL(ProfileDataTf, sb, eb, hh, ll);      
         rhh = MathCeil(hh/rg) * rg;
         rll = MathCeil(ll/rg) * rg;
         if (rhh < hh) rhh += rg;
         if (rll > ll) rll -= rg;      
      
         dparam[MPDP_ONETICK]    = gdOneTick;
         dparam[MPDP_HH]         = rhh;
         dparam[MPDP_LL]         = rll;
         dparam[MPDP_VAPERCENT]  = VAPercent;

         iparam[MPIP_STARTBAR]   = sb;
         iparam[MPIP_ENDBAR]     = eb; 
         iparam[MPIP_DIGITS]     = giDigits;
         iparam[MPIP_STEP]       = giStep;  
         //<--Prepare data for library fn call  
         
         //-->call library
         MpGet
            (  
                 dparam       //double    dparam[4]
               , iparam       //int       iparam[4]
               , gdaRates     //double    arates[][6]
               , mpdata       //double&   mpdata[][MPSIZE]                                  //result: data
               , mplines      //int&      mplinesidx[MPLNSIZE]                              //result: lines index
               , mptotal      //double&   mptotal[MPTSIZE]                                  //result: total (tpo, vol)
               , mpletter     //int&      mpletter[][MPLTSIZE]                              //result: letter  
            );
         //<--call library         
      
         mpdatasize = ArraySize(mpdata)/MPSIZE;
         maxtpo     = mpdata[ mplines[MPL_TPOPOC] ][MP_TPO];            
         
         //--calculate startprofile  
         startprofile = laststartprofile + maxtpo + space;   
         if ( ShowSplitProfileDay && (iday<SplitProfileNumDays || bcurrsession) ) startprofile += (2*(sb - eb)) +6;
        
         if ( ShowSplitProfileSes && (ises<SplitProfileNumSes || bcurrsession) ) startprofile += (2*(sb - eb)) +6;
         
         if ( startprofile > (Bars-1))  continue;
         
         //-->some conditions shortcut                  
         bmaxdays1andcurrses    = (maxdays==1 && bcurrsession);   //--we are in current session and only day 0 will be updated       
         bmaxtpochange          = (lastmaxtpo != maxtpo);         //--maxtpo change         
         bmaxtpochangeornewbar  = (newbar || bmaxtpochange);      //--maxtpo change or new bar occurred         
         bmaxtpochangeandnewbar = (newbar && bmaxtpochange);      //--maxtpo change and new bar occurred                  
         //<--some conditions shortcut 
         
         if (bmaxdays1andcurrses) 
         {
            objtotal  = ObjectsTotal();
            //-->find all mp objects
            for (iobj = objtotal-1; iobj>=0; iobj--)
            {
               objname = ObjectName(iobj);   
               objtype = ObjectType(objname);                            
               isobjmp = (StringFind(objname, gsPref) != -1);
               
               if (!isobjmp) continue;
               
               //--get iday and ises obj 
               getDaySesObj(objname, idayobj, isesobj); 
               //obj is in current session and current day
               bobjincurrses = (idayobj == 0 && isesobj == ises);
               
               //--delete current session obj            
               if (bobjincurrses) ObjectDelete(objname);  
               
               //-->move all prev profile by one/two period 
               //---if newbar occurred or current session maxtpo changed 
               if (!bobjincurrses && bmaxtpochangeornewbar)
               {
                  int adj = 1;                  
                  //--maxtpo changed when newbar event occur                     
                  if (bmaxtpochangeandnewbar) adj++;
                  
                  moveObj(objname, objtype, adj);                                                                         
               }
               //<--move all prev profile       
            }
            //<--find all mp objects
            
            if (bmaxtpochange) lastmaxtpo = maxtpo;                                    
         }
                 
         //--update lastmaxtpo
         if ( (maxdays>1 && bcurrsession) ) lastmaxtpo = maxtpo;   
         //--update laststartprofile            
         laststartprofile = startprofile+4;
         
         //--> let setup the scrabble set
         drawPriceLetter
         (
              iday               //int    iday
            , ises               //int    ises
            , startprofile       //int    sbprofile
            , sb                 //int    sbdatatf
            , sb - eb            //int    totalbar
            , mpdatasize         //int    mpdatasize           
            , mpdata             //double mpdata[][]
            , mplines            //int    mplines[]
            , mpletter           //int    mpletter[][]
            , gcSesColor[ises]   //color  lettercolor
            , space              //int    spaceinfo
            , bcurrsession
         );   
         //<--
                       
         open      = iOpen(NULL, ProfileDataTf, sb);
         close     = iClose(NULL, ProfileDataTf, eb);               
         poc       = mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE];
         midrowpoc = mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE] - 0.5*(giStep*gdOneTick);
         vpoc      = mpdata[ mplines[MPL_VOLPOC] ][MP_PRICE];
         vah       = mpdata[ mplines[MPL_TPOVAH] ][MP_PRICE];
         val       = mpdata[ mplines[MPL_TPOVAL] ][MP_PRICE] - (giStep*gdOneTick); 
         halfback  = (hh+ll)/2;       
                
         //--Session IB                                      
         getHHLL(ProfileDataTf, sb, MathMax(sb-(IBNumBars-1), 0), ibh, ibl);
                                                             
         //profile ohlc bar
         drawBar( iday, ises, startprofile+2, open, hh, ll, close );
         //--value area
         createRect( "#" + iday + "#" + ises + ".va" 
            , vah, Time[ startprofile + 1 ]
            , val, Time[ startprofile - (maxtpo+1) ]
            , VAColor );          
         //--poc
         createText( "#" + iday + ".1.1.#" + ises + ".poc"
            , Time[startprofile - (maxtpo+1)]
            , poc
            , "n"
            , MPLFONTSIZE, "wingdings", POCColor
            );    
         //--vpoc 
          createText( "#" + iday + ".1.1.#" + ises + ".vpoc"
            , Time[startprofile - (maxtpo+1)]
            , vpoc
            , "u"
            , MPLFONTSIZE, "wingdings", POCColor
            );    
          //--halfback  
          createTl("#" + iday + ".1.1.#" + ises + ".hb"
            , Time[startprofile+1], halfback
            , Time[ startprofile - (maxtpo+1) ], halfback
            , Ivory, STYLE_SOLID, 2, false
            ); 
             
         //--ib
         createTl("#" + iday + ".1.1.#" + ises + ".ib"
            , Time[ startprofile + 1 ], ibh
            , Time[ startprofile + 1 ], ibl
            , POCColor, STYLE_SOLID, 3, false
            );   
            
         //--extended ib      
         if (ExtendIB)
         {     
            for (int ib=1; ib<5; ib++)
            {            
              createTl("#" + iday + ".1.1.#" + ises + ".ibh" + (ib+1) + "x"
                  , Time[ startprofile + 1 ], ibh+ib*(ibh-ibl)
                  , Time[ startprofile + 1 ], ibh+ib*(ibh-ibl)-0.5*gdOneTick
                  , POCColor, STYLE_SOLID, 2, false
                  ); 
            
               createTl("#" + iday + ".1.1.#" + ises + ".ibl" + (ib+1) + "x"
                  , Time[ startprofile + 1 ], ibl-ib*(ibh-ibl)
                  , Time[ startprofile + 1 ], ibl-ib*(ibh-ibl)-0.5*gdOneTick
                  , POCColor, STYLE_SOLID, 2, false
                  ); 
            }
         } 
         
         //--updateWindowInfo                     
         textwidth   = 0; 
         if (hh-ll!=0)
         double RangePerc = MathAbs((close-open)/(hh-ll)*100);
         datetime TD = iTime(NULL, ProfileDataTf, sb);
         int WeekDay = TimeDayOfWeek(TD);
         string NamDay;         
    switch                                  (WeekDay) {
    case 0 :   NamDay="SUNDAY";                      break;
    case 1 :   NamDay="MONDAY";                      break;
    case 2 :   NamDay="TUESDAY";                     break;
    case 3 :   NamDay="WEDNSDAY";                    break;
    case 4 :   NamDay="THURSDAY";                    break;
    case 5 :   NamDay="FRIDAY";                      break; 
    case 6 :   NamDay="SATURDAY";                    break;
    
    
  }
         strinfo[0]  = addStr(NamDay , " ", textwidth, false);
         strinfo[1]  = addStr(TimeToStr(iTime(NULL, ProfileDataTf, sb), TIME_DATE), " ", textwidth, false);          
         strinfo[2]  = addStr(DoubleToStr(mptotal[MPT_VOL], 0)     , " ", textwidth, false);  
         strinfo[3]  = addStr(DoubleToStr((hh-ll)/gdPoint, 0) 
         +" "+DoubleToStr((close-open)/gdPoint, 0) +" "+ DoubleToStr(RangePerc,0)+" %"   , " ", textwidth, false); 
         
       
       
         updateWindowInfo3
         (
              Time[startprofile]
            , iday
            , ises
            , strinfo
            , gcSesColor[ises]   //color  lettercolor
         );                                     
          
        
      }
      //<--session loop
   }
   //<--DAY LOOP   
}


/**
 *
 */
 
void updateWindowInfo3
(
     datetime infopos
   , int      iday
   , int      ises
   , string   data[]
   , color  sesslettercolor
)
{
   int     i 
         , imax     = ArraySize(data)
         , irow
         , startrow = WindowPriceMax(giWinId)-2
         ;
   color      lettercolor;  
   
   for (i=0, irow=startrow; i<imax; i++, irow--)
   {
   lettercolor = sesslettercolor;
      createText( "#" + iday + "#" + ises + ".info." + i
         , infopos
         , irow
         , data[i]
         , MPLFONTSIZE-1, MPLFONTNAME2, sesslettercolor
         , giWinId
         );       
   
   }
   
}
void drawPriceLetter
(
     int    iday
   , int    ises
   , int    sbprofile
   , int    sbdatatf
   , int    totalbar
   , int    mpdatasize           
   , double mpdata[][]
   , int    mplines[]
   , int    mpletter[][]
   , color  sesslettercolor
   , int    spaceinfo
   , bool   bcurrsession
)
{          
   
   int        maxtpoidx  = mplines[MPL_TPOPOC];
   double     maxtpo     = mpdata[maxtpoidx][MP_TPO];
   int        imaxtpo    = mpdata[maxtpoidx][MP_TPO];
   double     volratio;
   color      lettercolor;        
   int        step, i, j, pos, letterid, infopos;
   string     letter, strvolratio, emptystrvol = "   "; //3 spaces   
   double     openp, closep;//   =  gdaRates[sbdatatf-letterid][_CLOSE];
   double     halfback;
   
   
   for (step = 0; step < mpdatasize; step++) //+= giStep)
   {
      
      if (/*ShowHorizontalVolume && */mpdata[ step ][MP_VOL] > 0)
      {
         
         volratio    = 0;
         strvolratio = emptystrvol; //3 spaces
         if (mpdatasize > 3/*min step  required*/  && mpdata[ step ][MP_VOL] > 0)
         {
            if (step < mplines[MPL_VOLPOC] && (step+1) < mpdatasize)            
               volratio = mpdata[ step+1 ][MP_VOL] / mpdata[ step ][MP_VOL];                           
            
            if (step > mplines[MPL_VOLPOC] && (step-1) >= 0)            
               volratio = mpdata[ step-1 ][MP_VOL] / mpdata[ step ][MP_VOL];               
                     
            if (volratio >= MinVolumeRatio)
               strvolratio =  DoubleToStr(volratio,1);    
         }
         
         string strvol;
         if (ShowHorizontalVolume && ShowVolumeRatio)
         {
            strvol =  addStr(DoubleToStr(mpdata[ step ][MP_VOL],0) + "  " + strvolratio, " ", 45);   
            infopos = 9;                     
         }
         
         if (ShowHorizontalVolume && !ShowVolumeRatio)
         {
            strvol =  addStr(DoubleToStr(mpdata[ step ][MP_VOL],0), " ", 6);   
            infopos = 5;                       
         }
         
         if (!ShowHorizontalVolume && ShowVolumeRatio)
         {
            strvol =  addStr(strvolratio, " ", 6);    
            infopos = 5;                      
         }
         
         if (StringLen(StringTrimLeft(strvol)) != 0)
            createText( "#" + iday + ".1.2.#" + ises + ".vol." + step
               , Time[sbprofile+infopos]
               , mpdata[ step ][MP_PRICE]
               , strvol 
               , MPLFONTSIZE-2, MPLFONTNAME2, sesslettercolor
               );  
      }    
      
      pos = sbprofile;
      for (j=0; j<512; j++)
      {        
         if ( mpletter[step][j] == -1) break;
                           
         letterid =  mpletter[step][j] ;
         if (letterid>50) letterid = MathMod(letterid,50);
         
         letter = gsaLetter[ letterid ];
       
         if (PaintLettersOnVolume)            
         {
            double v0 = iVolume(NULL,ProfileDataTf,(sbdatatf - letterid) + 0);
            double v1 = iVolume(NULL,ProfileDataTf,(sbdatatf - letterid) + 1);
            double v2 = iVolume(NULL,ProfileDataTf,(sbdatatf - letterid) + 2);
            
            if ( v0<v1 && v0<v2 )
            {
               lettercolor = DownVolumeColor;
            }
            else   
            if ( v0>v1 && v0>v2 )
            {
               lettercolor = UpVolumeColor;
            }
            else lettercolor = NeutralVolumeColor;
         }
         else lettercolor = sesslettercolor;
         
         createText( "#" + iday + ".1.2.#" + ises + ".letter." + step + "-" + j
            , Time[pos]
            , mpdata[ step ][MP_PRICE]
            , letter
            , MPLFONTSIZE-3, MPLFONTNAME, lettercolor
            );          
         
         
         //--separated letters aka split profile
                 
         if (ShowSplitProfileDay && ( iday<SplitProfileNumDays||bcurrsession) )
         {

            int x = maxtpo + (mpletter[step][j]*2) +3;
                                   
            createText( "#" + iday + ".1.2.#" + ises + ".barletter." + step + "-" + mpletter[step][j] 
               , Time[sbprofile - x] 
               , mpdata[ step ][MP_PRICE]
               , letter
               , MPLFONTSIZE-3, MPLFONTNAME, lettercolor
               ); 
                      
             
            openp  = gdaRates[ sbdatatf - mpletter[step][j] ][_OPEN];   
            closep = gdaRates[ sbdatatf - mpletter[step][j] ][_CLOSE];   
            
            if (    openp <= mpdata[ step ][MP_PRICE] 
                 && openp >  mpdata[ step ][MP_PRICE] - (giStep*gdOneTick)
               )
            {
               createText( "#" + iday + ".1.1.#" + ises + ".barletter.openp." + mpletter[step][j] 
                  , Time[sbprofile - x ] 
                  , mpdata[ step ][MP_PRICE]
                  , " "
                  , MPLFONTSIZE-3, "Wingdings",  OpenCloseColor
                  );               
            
            }                     
               
            if (    closep <= mpdata[ step ][MP_PRICE] 
                 && closep >  mpdata[ step ][MP_PRICE] - (giStep*gdOneTick)
               )
            {
               createText( "#" + iday + ".1.1.#" + ises + ".barletter.closep." + mpletter[step][j] 
                  , Time[sbprofile - x ] 
                  , mpdata[ step ][MP_PRICE]
                  , " " //" `" //"  "
                  , MPLFONTSIZE-3, "Wingdings",  lettercolor
                  );               
            
            }
         
         }
            
            //--separated letters aka split session profiles
                 
         if (ShowSplitProfileSes && ( ises<SplitProfileNumSes||bcurrsession) )
         {

            int y = maxtpo + (mpletter[step][j]*2) +3;
                                   
            createText( "#" + iday + ".1.2.#" + ises + ".barletter." + step + "-" + mpletter[step][j] 
               , Time[sbprofile - y] 
               , mpdata[ step ][MP_PRICE]
               , letter
               , MPLFONTSIZE-3, MPLFONTNAME, lettercolor
               ); 
                          
            double Barhigh = gdaRates[ sbdatatf - mpletter[step][j] ][_HIGH];
            double Barlow = gdaRates[ sbdatatf - mpletter[step][j] ][_LOW];
            halfback = (Barhigh+Barlow)/2; 
            
            createText("#" + iday + ".1.1.#" + ises + ".barletter.hb" + mpletter[step][j]
            , Time[sbprofile - y]
            , halfback
            ," u "
            , MPLFONTSIZE-3, "Wingdings", Ivory
            );
                         
             
              
             
            openp  = gdaRates[ sbdatatf - mpletter[step][j] ][_OPEN];   
            closep = gdaRates[ sbdatatf - mpletter[step][j] ][_CLOSE];   
            
            
            if (    openp <= mpdata[ step ][MP_PRICE] 
                 && openp >  mpdata[ step ][MP_PRICE] - (giStep*gdOneTick)
               )
            {
               createText( "#" + iday + ".1.1.#" + ises + ".barletter.openp." + mpletter[step][j] 
                  , Time[sbprofile - y ] 
                  , mpdata[ step ][MP_PRICE]
                  , " "
                  , MPLFONTSIZE-3, "Wingdings",  OpenCloseColor
                  );   
                              
               
            
            }                     
               
            if (    closep <= mpdata[ step ][MP_PRICE] 
                 && closep >  mpdata[ step ][MP_PRICE] - (giStep*gdOneTick)
               )
            {
               createText( "#" + iday + ".1.1.#" + ises + ".barletter.closep." + mpletter[step][j] 
                  , Time[sbprofile - y ] 
                  , mpdata[ step ][MP_PRICE]
                  , " " //" `" //"  "
                  , MPLFONTSIZE-3, "Wingdings",  lettercolor
                  ); 
                                
            
            }
         }
         
         pos--;
      }  
   }   

}    
   
   
      


//+------------------------------------------------------------------+