//+------------------------------------------------------------------+
//|                                                  ay-mplib100.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property library
//+------------------------------------------------------------------+
//| My function                                                      |
//+------------------------------------------------------------------+
// int MyCalculator(int value,int value2)
//   {
//    return(value+value2);
//   }
//+------------------------------------------------------------------+
#include <ay-mplib.const.v102.mqh> 

void MpGet
   (
   
        double    dparam[4]
      , int       iparam[4]
      , double    arates[][6]
      , double&   mpdataperrow[][MPSIZE]  //result: price per row (price, tpo, vol)     
      , int&      mplinesidx[MPLNSIZE]    //result: lines index
      , double&   mptotal[MPTSIZE]        //result: total (tpo, vol)
      //, double&   mpdataperrow[][MPSIZE]  //result: price per row (price, tpo, vol)   
      , int&      mpletter[][MPLTSIZE]    //result: letter per row 
   )
{

   //-->extract params
   double     hh           = dparam[MPDP_HH]
            , ll           = dparam[MPDP_LL]
            , onetick      = dparam[MPDP_ONETICK]
            , vapercent    = dparam[MPDP_VAPERCENT]
            ;
     
   int        startbar     = iparam[MPIP_STARTBAR]
            , endbar       = iparam[MPIP_ENDBAR] 
            , digits       = iparam[MPIP_DIGITS]  
            , step         = iparam[MPIP_STEP]            
            ;
   
   double ticksize = step*onetick;        
   //<--extract params   
    
   double   sp;                                       //start price      
   double   midrangeprice = hh -( (hh-ll)/2.0 );     
   double   price, priceh, pricel; 
   double   barhp;                                    // bar high price
   double   barlp;                                    // bar low price
   double   barrange, rangeinrow;                     // bar range
   double   pipvol;                                   // volume per pip in bar range
   double   totaltpo, volinrow, totalvol, maxtpo, maxvol;
   int      i, j; 
   int      maxtpoidx, maxvolidx;           
   //int      mppricecount  = MathRound((hh - ll)/onetick) + 1;  
   int      mprowcount  = MathRound((hh - ll)/ticksize);// + 1; 
   bool inrow;
         
   //ArrayResize(mpdatapertick, mppricecount);
   ArrayResize(mpdataperrow, mprowcount);
   ArrayResize(mpletter, mprowcount);    
   
   //ArrayInitialize(mpdatapertick, 0.0);   
   ArrayInitialize(mplinesidx, MPNOIDX);   
   ArrayInitialize(mptotal, 0.0);     
   ArrayInitialize(mpdataperrow, 0.0);   
   ArrayInitialize(mpletter, MPNOIDX);

   //-->profile price level per onetick
   /*
   sp = hh;
   for (i=0; i<mppricecount; i++)
   {
      mpdatapertick[i][MP_PRICE] = NormalizeDouble(sp, digits);
      sp -= onetick;
   }
   */
   //<--profile price level per onetick    
        
   //-->price level per ticksize ( row )
   sp = hh;
   for (i=0; i<mprowcount; i++)
   {
      mpdataperrow[i][MP_PRICE] = NormalizeDouble(sp, digits);
      sp -= ticksize;
   }
   //<--price level per ticksize ( row )
            
   //-->profile letter per row
   for (i=0; i<mprowcount; i++)
   {
      priceh = mpdataperrow[i][MP_PRICE];
      pricel = priceh - ticksize;
    
      int letteridx = 0;
      int barnum    = 0;     
                     
      for (j=startbar; j>=endbar; j--)
      {
         
         barhp    = arates[j][_HIGH];//NormalizeDouble(arates[j][_HIGH], digits);
         barlp    = arates[j][_LOW]; //NormalizeDouble(arates[j][_LOW], digits);       
         
         barrange = ( (arates[j][_HIGH] - arates[j][_LOW]) / onetick); //MathMax( barhp - barlp, onetick ) / onetick;
         barrange = MathMax(barrange, 0.000001);
         pipvol   = MathMax( arates[j][_VOL] / barrange, 0.000001 );   
                
         //-->check at least one price of bar prices (from high to low) is in row
         inrow = false;    
         price = priceh; 
         while (price > pricel)
         {
                          
            //\\ xxxsome time things happen
            //\\ xxxNormalizeDouble(1.42007,4) is printed as 1.4201 but cant be == 1.4201
            //\\ xxxso ... my trick : MathAbs(price - barhp) < onetick
            if (    ((price <= barhp) || (price - barhp < onetick))
                 && (price >  barlp)// || MathAbs(price - barlp) < onetick) 
               ) 
            { inrow = true; break; }            
            
            price -= onetick;
         }
         //-->check at least one price of bar prices (from high to low) is in row
         
         //-->tpo, vol, letters
         if ( inrow )
         {
                                                                                                          
            mpdataperrow[i][MP_TPO] += 1.0;
            totaltpo                += 1.0; 
            
            rangeinrow  = ( MathMin(barhp, priceh) - MathMax(barlp, pricel) ) / onetick ;
            //if (rangeinrow            
            volinrow    = rangeinrow * pipvol;
                                       
            mpdataperrow[i][MP_VOL] += volinrow;                        
            totalvol                += volinrow;

            if (letteridx < MPLTSIZE) mpletter[i][letteridx] = barnum;
            
            letteridx++;
         }
         
         barnum++;
         //<--tpo, vol, letters

         //-->save maxtpo
         if ( mpdataperrow[i][MP_TPO] > maxtpo) 
         {
            maxtpo    = mpdataperrow[i][MP_TPO];
            maxtpoidx = i;               
         }
            
         if (mpdataperrow[i][MP_TPO] == maxtpo) 
         {
            // take the closest to the middle of profile range
            if (  MathAbs(midrangeprice - mpdataperrow[i][MP_PRICE]) 
                  < MathAbs(midrangeprice - mpdataperrow[maxtpoidx][MP_PRICE]) 
               )
            {
               maxtpo    = mpdataperrow[i][MP_TPO];
               maxtpoidx = i;
            }
         }
         //<--save maxtpo
            
         //-->save maxvol
         if (mpdataperrow[i][MP_VOL] > maxvol) 
         {
            maxvol    = mpdataperrow[i][MP_VOL];
            maxvolidx = i;               
         }
            
         if (mpdataperrow[i][MP_VOL] == maxvol) 
         {
            // take the closest to the middle of profile range
            if (   MathAbs(midrangeprice - mpdataperrow[i][MP_PRICE]) 
                  < MathAbs(midrangeprice - mpdataperrow[maxvolidx][MP_PRICE]) 
               )
            {
               maxvol    = mpdataperrow[i][MP_VOL];
               maxvolidx = i;
            }
         }
         //<--save maxvol         
         
      }
   }
   
   //<--profile letter per row   

   mplinesidx[MPL_TPOPOC] = maxtpoidx;
   mplinesidx[MPL_VOLPOC] = maxvolidx;

   mptotal[MPT_TPO] = totaltpo;
   mptotal[MPT_VOL] = totalvol;   
   
   //<--profile tpo, vpo per onetick     
   
   //-->calculate value area
   bool usevol = false;
   int vahidx, validx;
   for (i=0; i<2; i++)
   {                     
      vahidx=0; validx=0;
      if (i==1) usevol = true;
      
      _MPGetValueArea
      (        
           usevol
         , vapercent
         , mprowcount
         , mpdataperrow
         , maxtpo
         , maxtpoidx      
         , totaltpo
         , maxvol
         , maxvolidx
         , totalvol
         , vahidx
         , validx
      );
      
      if (usevol)
      {
         mplinesidx[MPL_VOLVAH] = vahidx;
         mplinesidx[MPL_VOLVAL] = validx;                  
      }
      else
      {
         mplinesidx[MPL_TPOVAH] = vahidx;
         mplinesidx[MPL_TPOVAL] = validx;   
      }
   }
   //<--calculate value area
              
/*              
   //-->profile tpo, vpo per onetick
   for (i=0; i<mppricecount; i++)
   {
      price = mpdatapertick[i][MP_PRICE];
      
      for (j=startbar; j>=endbar; j--)
      {
         barhp    = NormalizeDouble(arates[j][_HIGH], digits);
         barlp    = NormalizeDouble(arates[j][_LOW], digits);
         barrange = MathMax( barhp - barlp, onetick ) / onetick;
         pipvol   = MathMax( arates[j][_VOL] / barrange, 0.000001 );                   

         //-->tpo, vpo, totaltpo, totalvol       
         if ( price <= barhp && price >= barlp )   
         {                                   
            mpdatapertick[i][MP_TPO] += 1.0;
            mpdatapertick[i][MP_VOL] += pipvol;
            totaltpo += 1.0; 
            totalvol += pipvol;                                                                        
         }
         //<--tpo, vpo, totaltpo, totalvol
         
         //-->save maxtpo
         if ( mpdatapertick[i][MP_TPO] > maxtpo) 
         {
            maxtpo    = mpdatapertick[i][MP_TPO];
            maxtpoidx = i;               
         }
            
         if (mpdatapertick[i][MP_TPO] == maxtpo) 
         {
            // take the closest to the middle of profile range
            if (  MathAbs(midrangeprice - mpdatapertick[i][MP_PRICE]) 
                  < MathAbs(midrangeprice - mpdatapertick[maxtpoidx][MP_PRICE]) 
               )
            {
               maxtpo    = mpdatapertick[i][MP_TPO];
               maxtpoidx = i;
            }
         }
         //<--save maxtpo
            
         //-->save maxvol
         if (mpdatapertick[i][MP_VOL] > maxvol) 
         {
            maxvol    = mpdatapertick[i][MP_VOL];
            maxvolidx = i;               
         }
            
         if (mpdatapertick[i][MP_VOL] == maxvol) 
         {
            // take the closest to the middle of profile range
            if (   MathAbs(midrangeprice - mpdatapertick[i][MP_PRICE]) 
                  < MathAbs(midrangeprice - mpdatapertick[maxvolidx][MP_PRICE]) 
               )
            {
               maxvol    = mpdatapertick[i][MP_VOL];
               maxvolidx = i;
            }
         }
         //<--save maxvol   
         
      }
   }              
   //<--profile tpo, vpo per onetick         
   
*/        
}

/**
 * MPGetValueArea                                                   |
 * Private func                                             
 */
void _MPGetValueArea
(
     bool         usevolprofile
   , double       vapercent
   , int          mpdatasize
   , double       mpdata[][3]
   , double       maxtpo
   , int          maxtpoidx      
   , double       totaltpo
   , double       maxvol
   , int          maxvolidx
   , double       totalvol
   , int          &vahidx
   , int          &validx
)
{

   int    idx     = maxtpoidx;            
   if(usevolprofile) idx = maxvolidx;   
   
   double total   = totaltpo;             
   if(usevolprofile) total = totalvol;
   
   double vatvpo  = (vapercent/100.0) * total;  
       
   double tvpo    = mpdata[idx][MP_TPO];  if (usevolprofile) tvpo = mpdata[idx][MP_VOL];   

   int     upperidx_dp     = idx //dual prices(2 steps), upper poc 
         , loweridx_dp     = idx //dual prices(2 steps), lower poc   
         , lastupperidx    = idx
         , lastloweridx    = idx;    
         
   bool ontop=false, onbottom=false;
   int    loop=0;
      
   double utvpo1, utvpo2, ltvpo1, ltvpo2;
   int remainingtop, remainingbottom;
   while (tvpo <= vatvpo)   
   {      
            
      //if (loop >= mpdatasize) break;

      //-->new dual prices idx & checking for idx ontop/bottom
      
      //-->upperidx
      if ( (lastupperidx - 2) >= 0 ) 
      { 
         upperidx_dp = lastupperidx - 2; 
         utvpo1 = mpdata[upperidx_dp+1][MP_TPO]; /*---*/ if (usevolprofile) utvpo1 = mpdata[upperidx_dp+1][MP_VOL];       
         utvpo2 = mpdata[upperidx_dp  ][MP_TPO]; /*---*/ if (usevolprofile) utvpo2 = mpdata[upperidx_dp  ][MP_VOL];                  
      }
      else 
      {
         ontop = true;
         remainingtop = idx - (idx-lastupperidx);
         if (remainingtop==1)
         {
            utvpo1 = mpdata[lastupperidx-1][MP_TPO]; /*---*/ if (usevolprofile) utvpo1 = mpdata[lastupperidx-1][MP_VOL];    
            utvpo2 = 0;   
         }
         else
         {
            utvpo1=0; utvpo2=0;
         }
      }
      //<--upperidx
      
      //-->loweridx
      if ( (lastloweridx + 2) <= (mpdatasize-1) ) 
      {
         loweridx_dp = lastloweridx + 2;    
         ltvpo1 = mpdata[loweridx_dp-1][MP_TPO]; /*---*/ if (usevolprofile) ltvpo1 = mpdata[loweridx_dp-1][MP_VOL]; 
         ltvpo2 = mpdata[loweridx_dp  ][MP_TPO]; /*---*/ if (usevolprofile) ltvpo2 = mpdata[loweridx_dp  ][MP_VOL];          
      }
      else
      {
         onbottom = true;
         remainingbottom = (mpdatasize-1) - lastloweridx;
         if (remainingbottom==1)
         {
            ltvpo1 = mpdata[lastloweridx+1][MP_TPO]; /*---*/ if (usevolprofile) ltvpo1 = mpdata[lastloweridx+1][MP_VOL];   
            ltvpo2 = 0;    
         }
         else
         {
            ltvpo1=0; ltvpo2=0;
         }         
      }
      //<--loweridx
      
      //<--new dual prices idx


      
      //-->check if vatvo reached by single step       
      if ( ((tvpo + utvpo1) >= vatvpo) || ((tvpo + ltvpo1) >= vatvpo) )
      {
         
         if ( utvpo1 >= ltvpo1 )
         {
            
            if (ontop) lastupperidx--;
            else lastupperidx = upperidx_dp+1;
               
            tvpo += utvpo1;      
                        
            break;
         }
         else 
         //if ( utvpo1 < ltvpo1 )        
         {
            
            if (onbottom)  lastloweridx--;
            else lastloweridx = loweridx_dp-1;
            
            tvpo += ltvpo1;
                     
            break;
         }                     
         
      }      
      //<--check if vatvo reached by single step      

      //2 step prices
      double tvpo2upper = utvpo1 + utvpo2;
      double tvpo2lower = ltvpo1 + ltvpo2;
      
      if (  tvpo2upper > tvpo2lower )
      {
         lastupperidx = upperidx_dp;
         tvpo += tvpo2upper;
      }
      else
      if (  tvpo2upper < tvpo2lower )
      {
         lastloweridx = loweridx_dp;
         tvpo += tvpo2lower;
      }
      else 
      if ( tvpo2upper == tvpo2lower )
      {
         if (idx - upperidx_dp >= loweridx_dp - idx)
         {
            lastloweridx = loweridx_dp;
            tvpo += tvpo2lower;   
         }
         else
         {     
            lastupperidx = upperidx_dp;
            tvpo += tvpo2upper;
         }
      
      }      
      
      //loop++;
      
   }//end  while (tvpo <= vatvpo)
   
   vahidx = lastupperidx;
   validx = lastloweridx;     

}